// user interface auf LCD ausgeben
void lcd_draw_ui( int ui_num ) {
	
	// lcd leeren
	lcd_clrscr();

	// startmen ausgeben
	if ( ui_num == 0 ){
		
		// cursor ausschalten
		lcd_init(LCD_DISP_ON);

		lcd_gotoxy(0,0);
		lcd_puts("   Select Program");
		lcd_gotoxy(1,1);
		lcd_puts("FastDraw  Stopwatch");
		lcd_gotoxy(1,2);
		lcd_puts("IPSC      PPC");
		lcd_gotoxy(1,3);
		lcd_puts("Chrono    Duel");
		
		// zu active_programm korrespondierenden wert auf dem LCD anzeigen
		switch (active_programm) {
			case 0: 
			lcd_gotoxy(0,1);
			lcd_puts(">");
			break;

			case 1:
			lcd_gotoxy(0,2);
			lcd_puts(">");
			break;

			case 2: 
			lcd_gotoxy(0,3);
			lcd_puts(">");
			break;

			case 3:
			lcd_gotoxy(10,1);
			lcd_puts(">");
			break;

			case 4: 
			lcd_gotoxy(10,2);
			lcd_puts(">");
			break;

			case 5:
			lcd_gotoxy(10,3);
			lcd_puts(">");
			break;
		}
	}

	// fast draw setup men ausgeben
	if ( ui_num == 1 ) {
		
		// cursor anschalten
		lcd_init(LCD_DISP_ON_CURSOR);

		lcd_gotoxy(0,0);
		lcd_puts("  Fast Draw Setup    ");

		lcd_gotoxy(0,2);
		lcd_puts("Start delay: ");
		
		sprintf(buffer, "%1dm%02ds", config_fastdraw[0] / 60, config_fastdraw[0] % 60);
		lcd_puts(buffer);
		
		lcd_gotoxy(0,3);		
		lcd_puts("Runtime:     ");
		sprintf(buffer, "%1dm%02ds", config_fastdraw[1] / 60, config_fastdraw[1] % 60);
		lcd_puts(buffer);
		
		// zur cursor_position korrespondierenden wert auf dem LCD anzeigen
		switch(cursor_position) {
			case 0:
				lcd_gotoxy(13,2);
				break;
			case 1:
				lcd_gotoxy(15,2);
				break;
			case 2:
				lcd_gotoxy(16,2);
				break;
			case 3:
				lcd_gotoxy(13,3);
				break;
			case 4:
				lcd_gotoxy(15,3);
				break;
			case 5:
				lcd_gotoxy(16,3);
				break;
		}
	}
}





// programm auswahl in main schleife
int main(void) {

	// LCD initialisieren
    	lcd_init(LCD_DISP_ON);
	lcd_command(LCD_CLR);


	// startmen ausgeben
	lcd_draw_ui(0);

	while (1) {
		
		// wenn runter taste gedrckt auswahl erhhen
		if ( button_active(down) && active_programm < 5) {
			active_programm++;
			lcd_draw_ui(3);
			_delay_ms(100);
		}

		// wenn hoch taste gedrckt auswahl erniedrigen
		if ( button_active(up) && active_programm != 0) {
			active_programm--;
			lcd_draw_ui(3);
			_delay_ms(100);
		}

		// wenn links taste gedrckt in rechte spalte wechseln
		if ( button_active(left)  && active_programm > 2) {
			active_programm -= 3;
			lcd_draw_ui(3);
			_delay_ms(100);
		}
		
		// wenn rechts taste gedrckt in links spalte wechseln
		if ( button_active(right) && active_programm < 3) {
			active_programm += 3;
			lcd_draw_ui(3);
			_delay_ms(100);
		}
		
		// wenn enter gedrckt ausgewhltes programm starten
		if ( button_active(enter) ) {
			switch (active_programm) {

				// fastdraw starten
				case 0:
				_delay_ms(100);
				programm_fastdraw();
				break;

				// ipsc starten
				case 1:
				_delay_ms(100);
				programm_ipsc();
				break;
			}
		}
	}
}


// ####
// # hier der auszug aus dem code des setup mens fr das userinterface 1
// ####

// wenn hoch-taste gedrckt prfen an welcher stelle der cursor ist und entsprechenden
// wert im setup array ndern
// die berprfung ob der zulssige bereich verlassen wurde fehlt hier noch
if ( button_active(up)) {
	switch (cursor_position) {

		// startverzgerung + 60 sekunden
		case 0:
		config_fastdraw[0] += 60;
		// wenn wert gendert ui neu zeichnen
		lcd_draw_ui(1);
		_delay_ms(100);
		break;
		
		// startverzgerung + 10 sekunden
		case 1:
		config_fastdraw[0] += 10;
		// wenn wert gendert ui neu zeichnen
		lcd_draw_ui(1);
		_delay_ms(100);
		break;
		
		// startverzgerung + 1 sekunde
		case 2:
		config_fastdraw[0]++;
		// wenn wert gendert ui neu zeichnen
		lcd_draw_ui(1);
		_delay_ms(100);
		break;

		// laufzeit - 60 sekunden
		case 3:
		config_fastdraw[1] += 60;
		// wenn wert gendert ui neu zeichnen
		lcd_draw_ui(1);
		_delay_ms(100);
		break;
		
		// laufzeit - 10 sekunden
		case 4:
		config_fastdraw[1] += 10;
		// wenn wert gendert ui neu zeichnen
		lcd_draw_ui(1);
		_delay_ms(100);
		break;
		
		// laufzeit - 1 sekunde
		case 5:
		config_fastdraw[1]++;
		// wenn wert gendert ui neu zeichnen
		lcd_draw_ui(1);
		_delay_ms(100);
		break;
	}

}	

// wenn rechts taste gedrckt cursor um eins nach rechts verschieben				
if ( button_active(right) && cursor_position < 5 ) {
	cursor_position++;
	// wenn position gendert ui neu zeichnen
	lcd_draw_ui(1);
	_delay_ms(100);
}

// wenn links taste gedrckt cursor um eins nach links verschieben
if ( button_active(left) && cursor_position != 0) {
	cursor_position--;
	// wenn position gendert ui neu zeichnen
	lcd_draw_ui(1);
	_delay_ms(100);
}
